SystemOrganization addCategory: #'Glamour-Helpers'!

!Boolean methodsFor: '*glamour-helpers' stamp: ' 25/2/09 11:51'!
glamourValueWithArgs: anArray 
	 
	^self! !

Object subclass: #GLMNotNilCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMNotNilCondition commentStamp: '<historical>' prior: 0!
Used to test if all defined arguments of a condition or not nil.

We use this as a default condition for presentations. Usually, you will want to define a condition as a block such as '[ :class :category | (class isKindOf: Class) and: [ category isKindOf: Symbol ] ]' (or something like that) but sometimes you just want to make sure that all arguments are defined. Since we do not know the number of arguments in advance, we use this class to interpret #glamourValueWithArgs: and return true if all arguments are not nil.!

!GLMNotNilCondition methodsFor: 'glamour' stamp: ' 25/2/09 11:51'!
glamourValueWithArgs: anArray 
	 
	^(anArray includes: nil) not! !

!Object methodsFor: '*glamour-helpers' stamp: 'tg 2/25/2009 13:32'!
glamourValue: anObject 
	 
	^self 
		glamourValueWithArgs: 
			((anObject isKindOf: GLMMultiValue) 
				ifTrue: [anObject asArray] 
				ifFalse: [Array with: anObject])! !

!Object methodsFor: '*glamour-helpers' stamp: ' 25/2/09 11:51'!
glamourValueWithArgs: anArray 
	 
	^self! !

!Object methodsFor: '*glamour-helpers' stamp: ' 25/2/09 11:51'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderObject: self! !

!Symbol methodsFor: '*glamour-helpers' stamp: ' 25/2/09 11:51'!
glamourValueWithArgs: anArray 
	 
	anArray size < 1 ifTrue: [^nil]. 
	^anArray first perform: self! !

!BlockClosure methodsFor: '*glamour-helpers' stamp: ' 25/2/09 11:51'!
glamourValueWithArgs: anArray 
	"This is the same as valueWithPossibleArgs: from squeak. 
	Unfortunately, VW's cullValue: is incompatible." 
	 
	self numArgs = 0 ifTrue: [^self value]. 
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray]. 
	self numArgs > anArray size 
		ifTrue: 
			[^self 
				valueWithArguments: anArray , (Array new: self numArgs - anArray size)]. 
	^self 
		valueWithArguments: 
			(anArray 
				copyFrom: 1 
				to: self numArgs)! !
